org 0h

        push cs
        pop ds

        mov ax, 35FEh           ; Get Some Info
        int 21h
        mov [dataseg], es
        mov [dataoff], bx
        mov si, bx

    ; ---- INIT
        mov [sega], cs
        mov [segb], cs

        mov WORD es:[si]  , 83h     ; Function 83h - Add GUI-Element
        mov      es:[si+2], cs      ; Seg
        mov WORD es:[si+4], guia    ; Off
        int 0FFh
        mov ax, es:[si+6]           ; Get Handle
        mov [handa], al

        mov bx, guia
        mov WORD [bx], 3
        mov WORD [bx+4], 60
        int 0FFh
        mov ax, es:[si+6]           ; Get Handle
        mov [handab], al

        mov WORD es:[si+4], guib    ; Off
        int 0FFh
        mov ax, es:[si+6]           ; Get Handle
        mov [handb], al        
        
mainexecloop:
        mov ax, 9               ; Function 9h - kbhit?
        mov es:[si], ax
        int 0FFh
        mov ax, es:[si+2]
        cmp ax, 0
        jnz kbhit               ; Yes -> Jmp kbhit

        mov ax, 3               ; Function 3h - Get last signal
        mov es:[si], ax
        mov ax, 0FFh            ; Get own signal
        mov es:[si+2], ax
        int 0FFh                ; DO that!
        mov ax, es:[si+4]
        cmp ax, 1               ; Signal 1 (Paint)?
        jz dopaintme
        cmp ax, 2               ; Signal 2 (Term)?
        jz quitme

        mov WORD es:[si], 82h   ; Function 82h - Display
        mov WORD es:[si+2], 12h ; SubFuntion 12h - Checkclick
        mov WORD es:[si+4], 255 ; If inactive return 255
        int 0FFh
        mov ax, es:[si+4]
        cmp al, [handa]         ; Is it the button 1 (Quit)?
        jz quitme
        cmp al, [handb]         ; Is it the button 2 (Re-Call)?
        jz callme
        nop
    ; ---- SIGNAL PROCESSING

dotswitch:                      
        int 0FCh
        push cs
        pop ds
        mov es, [dataseg]
        mov si, [dataoff]
        jmp mainexecloop

dopaintme: jmp paintme

callme:
        mov WORD es:[si], 0fh       ; Function Fh - Exec
        mov      es:[si+2], cs      ; Seg
        mov WORD es:[si+4], guiprog ; Off
        int 0FFh
        jmp dotswitch
        
quitme:

    ; ---- TERMINATION
        
        xor ax,ax               ; Function 0 - Kill
        mov es:[si], ax
        mov ax, cs              ; Store CS
        mov es:[si+2], ax
        int 0FFh                ; DO that (bye,bye)
            ; Still there? Let's do a taskswitch
        int 0FCh
            ; Really killed. If not: hang in a quit-loop
        jmp quitme

kbhit:
        mov ax, 0ah             ; Function a - getch
        mov es:[si], ax
        int 0FFh
        mov ax, es:[si+2]       ; Get it in AL

    ; ---- Q=Quit, but you can modify this here

        mov ah, al
        or al, 32               ; Make lowercase
        cmp al, 'q'             ; q(uit)
        jz quitme
        cmp al, 'd'             ; (re)d(raw)
        jz dopaintme

    ; ---- KEY PROCESSING

        jmp dotswitch           ; Let's make a taskswitch
    
paintme:
        mov WORD es:[si], 82h   ; Function 82h - Display
        mov WORD es:[si+2], 5   ; SubFunction 5h - paint rectangle
        mov WORD es:[si+4], 0FFFFh ; FFFFh - Paint entire rectangle
        mov WORD es:[si+12], 1  ; Color 1 
        int 0FFh                ; DO that!

        mov WORD es:[si+2], 11h ; Repaint GUI
        int 0FFh
        
    ; ---- PAINTING

        jmp dotswitch           ; Let's make a taskswitch


dataseg dw 0
dataoff dw 0

    ; ---- VARIABLES

handa   db 0
handab  db 0
handb   db 0

guia:   dw 2                    ; Make easybutton
        dw 20,20,0,0            ; X/Y = 20 (no X2,Y2)
sega    dw 0,bttext             ; Text
        dw 1                    ; Font 1
        dw 0,0,0,0              ; nothing else

guib:   dw 2                    ; Make easybutton
        dw 20,100,0,0           ; X/Y = 20,100 (no X2,Y2)
segb    dw 0,bttext2            ; Text
        dw 1                    ; Font 1
        dw 0,0,0,0              ; nothing else

bttext: db 'Quit me',0
bttext2: db 'Call me again',0
guiprog: db 'guitest.uxe',0
